<template>
	<div class="auxiliary-advice-container layout-padding">
		<div class="layout-padding-auto layout-padding-view pd20">
			<el-form :model="state.queryParams" ref="ruleFormRef" inline @submit.native.prevent>
				<el-form-item label="意见类型" prop="CommonType">
					<el-select v-model="state.queryParams.CommonType" placeholder="请选择意见类型" @change="handleQuery">
						<el-option v-for="item in commonType" :value="item.key" :key="item.key" :label="item.value" />
					</el-select>
				</el-form-item>
				<el-form-item label="常用语分类" prop="isOpen">
					<el-select v-model="state.queryParams.isOpen" placeholder="请选择意见类型" @change="handleQuery">
						<el-option v-for="item in openState" :value="item.key" :key="item.key" :label="item.value" />
					</el-select>
				</el-form-item>
				<el-form-item>
					<el-button type="primary" @click="handleQuery" :loading="state.loading"> <SvgIcon name="ele-Search" class="mr5" />查询 </el-button>
					<el-button @click="resetQuery(ruleFormRef)" class="default-button" :loading="state.loading">
						<SvgIcon name="ele-Refresh" class="mr5" />重置
					</el-button>
				</el-form-item>
			</el-form>
			<vxe-toolbar
				ref="toolbarRef"
				:loading="state.loading"
				custom
				:refresh="{
					queryMethod: handleQuery,
				}"
			>
				<template #buttons>
					<el-button type="primary" @click="onAdviceAdd" :loading="state.loading"> <SvgIcon name="ele-Plus" class="mr5" />新增常用意见</el-button>
					<el-button type="danger" @click="onAdviceDelete" :disabled="isChecked"> <SvgIcon name="ele-Delete" class="mr5" />删除</el-button>
				</template>
			</vxe-toolbar>
			<div style="overflow: hidden; width: 100%; height: 100%; flex: 1">
				<vxe-table
					border
					:loading="state.loading"
					:data="state.tableData"
					:column-config="{ resizable: true, useKey: true }"
					:row-config="{ isCurrent: true, isHover: true, useKey: true, height: 30 }"
					ref="tableRef"
					height="auto"
					auto-resize
					show-overflow
					:scrollY="{ enabled: true, gt: 100 }"
					id="auxiliaryAdvice"
					:custom-config="{ storage: true }"
					@checkbox-all="selectAllChangeEvent"
					@checkbox-change="selectChangeEvent"
				>
					<vxe-column type="checkbox" width="60" align="center"></vxe-column>
					<vxe-column field="content" title="意见内容" min-width="300"></vxe-column>
					<vxe-column field="commonTypeText" title="意见类型" min-width="150"></vxe-column>
					<vxe-column field="isOpen" title="常用意见分类" min-width="150">
						<template #default="{ row }">
							{{ row.isOpen ? '公开常用意见' : '个人常用意见' }}
						</template>
					</vxe-column>
					<vxe-column field="creatorName" title="创建人" min-width="120"></vxe-column>
					<vxe-column field="creatorOrgName" title="创建部门" min-width="140"></vxe-column>
					<vxe-column field="creationTime" title="创建时间" width="160">
						<template #default="{ row }">
							{{ formatDate(row.creationTime, 'YYYY-mm-dd HH:MM:SS') }}
						</template>
					</vxe-column>
					<vxe-column title="操作" fixed="right" width="90" align="center">
						<template #default="{ row }">
							<el-button link type="primary" @click="updateAdvice(row)" v-auth="'auxiliary:advice:edit'" title="修改参数"> 修改 </el-button>
						</template>
					</vxe-column>
				</vxe-table>
			</div>
			<pagination
				@pagination="queryList"
				:total="state.total"
				v-model:current-page="state.queryParams.PageIndex"
				v-model:page-size="state.queryParams.PageSize"
				:disabled="state.loading"
			/>
		</div>
		<!--  常用意见新增  -->
		<advice-add ref="adviceAddRef" @updateList="queryList" :commonType="commonType" />
		<!--  常用意见编辑  -->
		<advice-edit ref="adviceEditRef" @updateList="queryList" :commonType="commonType" />
	</div>
</template>

<script lang="tsx" setup name="auxiliaryAdvice">
import { computed, defineAsyncComponent, onMounted, reactive, ref } from 'vue';
import { ElMessage, ElMessageBox, FormInstance } from 'element-plus';
import { formatDate } from '@/utils/formatTime';
import { commonBaseData, deleteCommon, publicCommonList } from '@/api/auxiliary/advice';

// 引入组件
const AdviceAdd = defineAsyncComponent(() => import('@/views/auxiliary/advice/components/Advice-add.vue')); // 常用意见新增
const AdviceEdit = defineAsyncComponent(() => import('@/views/auxiliary/advice/components/Advice-edit.vue')); // 常用意见编辑
const pagination = defineAsyncComponent(() => import('@/components/ProTable/components/Pagination.vue')); // 分页

// 定义变量内容
const state = reactive({
	loading: false, // 加载状态
	queryParams: {
		// 查询参数
		PageIndex: 1,
		PageSize: 20,
		CommonType: null, // 常用意见类型
		isOpen: null, // 是否公开
	},
	total: 0, // 总条数
	tableData: [], // 表格数据
});
const ruleFormRef = ref<RefType>(null); // 表单ref
const commonType = ref<EmptyArrayType>([]); // 常用意见类型
const openState = ref<EmptyArrayType>([
	{
		key: true,
		value: '公开常用意见',
	},
	{
		key: false,
		value: '个人常用意见',
	},
]); // 是否公开
const getBaseData = async () => {
	try {
		const res = await commonBaseData();
		commonType.value = res.result?.commonType ?? [];
	} catch (error) {
		console.log(error);
	}
};
/** 搜索按钮操作 */
const handleQuery = () => {
	state.queryParams.PageIndex = 1;
	queryList();
};
// 获取列表
const queryList = () => {
	state.loading = true;
	publicCommonList(state.queryParams)
		.then((res) => {
			state.loading = false;
			state.tableData = res.result.items ?? [];
			state.total = res.result.total ?? 0;
			tableRef.value.clearCheckboxRow();
			checkTable.value = [];
		})
		.finally(() => {
			state.loading = false;
			tableRef.value.clearCheckboxRow();
			checkTable.value = [];
		});
};
// 重置表单
const resetQuery = (formEl: FormInstance | undefined) => {
	if (!formEl) return;
	formEl.resetFields();
	queryList();
};
// 新增意见
const adviceAddRef = ref<RefType>(); // 意见新增
const onAdviceAdd = () => {
	adviceAddRef.value.openDialog();
};
// 修改意见
const adviceEditRef = ref<RefType>(); // 修改意见
const updateAdvice = (row: any) => {
	adviceEditRef.value.openDialog(row);
};
// 删除参数
const onAdviceDelete = () => {
	const ids = checkTable.value.map((item: any) => item.id);
	ElMessageBox.confirm(`您确定要删除选中的常用意见，是否继续?`, '提示', {
		confirmButtonText: '确认',
		cancelButtonText: '取消',
		type: 'warning',
		draggable: true,
		cancelButtonClass: 'default-button',
		autofocus: false,
	})
		.then(() => {
			deleteCommon({ ids }).then(() => {
				ElMessage.success('操作成功');
				queryList();
			});
		})
		.catch(() => {});
};
const tableRef = ref<RefType>();
const checkTable = ref<EmptyArrayType>([]);
const selectAllChangeEvent = ({ checked }) => {
	if (tableRef.value) {
		const records = tableRef.value.getCheckboxRecords();
		checkTable.value = records;
		console.log(checked ? '所有勾选事件' : '所有取消事件', records);
	}
};

const selectChangeEvent = ({ checked }) => {
	if (tableRef.value) {
		const records = tableRef.value.getCheckboxRecords();
		checkTable.value = records;
		console.log(checked ? '勾选事件' : '取消事件', records);
	}
};
const isChecked = computed(() => {
	return !Boolean(checkTable.value.length);
});
const toolbarRef = ref<RefType>();
// 页面加载时
onMounted(() => {
	queryList();
	if (tableRef.value && toolbarRef.value) {
		tableRef.value.connect(toolbarRef.value);
	}
	getBaseData();
});
</script>
